{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 14-05-2002
  Versión actual: 1.0.3
  Fecha versión actual: 29-06-2004
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    13-04-2003    p262. Poder realizar el informe para todos los proveedores.

    07-03-2004    p272. Adaptación a multiempresa.

    29-06-2004    p274. Migración a FastReport.
===============================================================================
}

unit InformeListadoPedidosProv;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  InformeBase, IBDatabase, Db, FR_IBXDB, FR_Shape, FR_Class, FR_DSet,
  FR_DBSet, IBCustomDataSet, IBQuery, Tipos;

type
  TdmInformeListadoPedidosProv = class(TdmInformeBase)
    TablaPedidos: TIBQuery;
    frdsTablaPedidos: TfrDBDataSet;
  private
    FFechaIni: Variant;
    FFechaFin: Variant;
    FTipo: TTipoInforme;
    FCodigoProveedor: Variant;
    FNombreProveedor: Variant;
    procedure InformeGetParametersText(Memo : TStringList);
  protected
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property FechaIni : Variant read FFechaIni write FFechaIni;
    property FechaFin : Variant read FFechaFin write FFechaFin;
    property CodigoProveedor : Variant read FCodigoProveedor write FCodigoProveedor;
    property NombreProveedor : Variant read FNombreProveedor write FNombreProveedor;
    property Tipo : TTipoInforme read FTipo write FTipo;
  end;

var
  dmInformeListadoPedidosProv: TdmInformeListadoPedidosProv;

implementation

{$R *.DFM}

{ TdmInformeListadoPedidosProv }

uses
  RdxEmpresaActiva, Literales, Variants;

constructor TdmInformeListadoPedidosProv.Create(
  AOwner: TComponent);
begin
  inherited;
  FFechaIni := NULL;
  FFechaFin := NULL;
  FCodigoProveedor := NULL;
  FNombreProveedor := NULL;
  FTipo := tiTodo;
  FNombreInforme := 'ListadoPedidosProv.frf';
  // ˇˇˇ REVISAR !!!
//  OnGetParametersText := InformeGetParametersText;
end;

procedure TdmInformeListadoPedidosProv.InformeGetParametersText(
  Memo: TStringList);
begin
  with Memo do
  begin
    if Tipo = tiTodo then
      Add(msgInfIntervaloTodosPro)
    else
      Add(SysUtils.Format('%s - %s', [FCodigoProveedor, FNombreProveedor]));
    Add(SysUtils.Format(msgInfIntervaloFec, [FFechaIni, FFechaFin]))
  end;
end;

procedure TdmInformeListadoPedidosProv.PrepararConsultas;
begin
  with TablaPedidos do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('select CODIGO, FECHAALTA, NOMBRE, FECHAEMISION, FECHARECEPCION, ');
    SQL.Add('SITUACION, IMPORTETOTAL, ');
    SQL.Add('EXTRACT (MONTH FROM FECHAALTA)||''/''||EXTRACT (YEAR FROM FECHAALTA) as MES ');    
    SQL.Add('from PEDIDOSPROVEEDOR ');
    SQL.Add('where (FECHAALTA between :FECHAINI and :FECHAFIN) ');
    SQL.Add('and (CODIGOEMPRESA = :CODIGOEMPRESA) ');
    if Tipo = tiPorProveedor then
    begin
      SQL.Add('and CODIGOPROVEEDOR = :CODIGOPROVEEDOR ');
      ParamByName('CODIGOPROVEEDOR').AsString := FCodigoProveedor;
    end;
    SQL.Add('order by FECHAALTA, NOMBRE, CODIGO');

    ParamByName('FECHAINI').AsDate := FFechaIni;
    ParamByName('FECHAFIN').AsDate := FFechaFin;
    ParambyName('CODIGOEMPRESA').AsInteger := EmpresaActiva.Codigo;
    Prepare;
  end;
end;

end.
